#include "StdAfx.h"
#include "ADIS16365.h"
#include <assert.h>
#include "ADIS16365_MemoryMap.h"

ADIS16365::ADIS16365()
{
	_connected = Initialize("\\\\.\\Ezusb-0");
}

ADIS16365::~ADIS16365(void)
{
}

bool ADIS16365::GetMeasure(double *measure)
{
	if (!_connected) return false;

	short data[ADIS16365_DATA_NUM];
	
	data[0] = ReadInt14(SUPPLY_OUT);
	data[1] = ReadInt14(XGYRO_OUT);
	data[2] = ReadInt14(YGYRO_OUT);
	data[3] = ReadInt14(ZGYRO_OUT);
	data[4] = ReadInt14(XACCL_OUT);
	data[5] = ReadInt14(YACCL_OUT);
	data[6] = ReadInt14(ZACCL_OUT);
	data[7] = ReadInt14(XTEMP_OUT);
	data[8] = ReadInt14(YTEMP_OUT);
	data[9] = ReadInt14(ZTEMP_OUT);
	data[10]= ReadInt14(AUX_ADC);

	_lastData[0] = data[0]*5./2068.;			// V
	
	for (int i=1; i<4; i++) {
		_lastData[i] = data[i]*300./6000.;		// deg/sec
	}
	for (int i=4; i<7; i++) {
		_lastData[i] = data[i]*18./5401.;		// g
	}
	for (int i=7; i<10; i++)	{
		_lastData[i] = data[i]*80./588. + 25.;	// Celsius temperature
	}
	_lastData[10] = data[10] * 3.3/4095;		// V

	if(measure) {
		memcpy (measure, _lastData, sizeof(double)*ADIS16365_DATA_NUM);
	}
	return true;
}
