#include "StdAfx.h"
#include "ADIS16405.h"
#include <assert.h>
#include "ADIS16405_MemoryMap.h"


ADIS16405::ADIS16405()
{
	_connected = Initialize("\\\\.\\Ezusb-0");
}

ADIS16405::~ADIS16405(void)
{
}

bool ADIS16405::GetMeasure(double *measure)
{
	if (!_connected) return false;

	short data[ADIS16405_DATA_NUM];

	data[0] = ReadInt14(SUPPLY_OUT);
	data[1] = ReadInt14(XGYRO_OUT);
	data[2] = ReadInt14(YGYRO_OUT);
	data[3] = ReadInt14(ZGYRO_OUT);
	data[4] = ReadInt14(XACCL_OUT);
	data[5] = ReadInt14(YACCL_OUT);
	data[6] = ReadInt14(ZACCL_OUT);
	data[7] = ReadInt14(XMAGN_OUT);
	data[8] = ReadInt14(YMAGN_OUT);
	data[9] = ReadInt14(ZMAGN_OUT);
	data[10]= ReadInt14(TEMP_OUT);
	data[11]= ReadInt14(AUX_ADC);

	_lastData[0] = data[0]*5./2068.;			// V
	
	for (int i=1; i<4; i++) {
		_lastData[i] = data[i]*300./6000.;		// deg/sec
	}
	for (int i=4; i<7; i++) {
		_lastData[i] = data[i]*18./5401.;		// g
	}
	for (int i=7; i<10; i++)	{
		_lastData[i] = data[i]*0.0005;			// gauss
	}
	_lastData[10] = data[10]*80./588. + 25.;	// Celsius temperature
	_lastData[11] = data[11] * 3.3/4095;		// V

	if(measure) {
		memcpy (measure, _lastData, sizeof(double)*ADIS16405_DATA_NUM);
	}
	return true;
}
